<?php 
/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */



include_once('AbstractSubject.php');
include_once('ExempleObserver.php');



/**
 * Exemple de classe qui observe un sujet
 * 
 */
class ExempleSubject extends AbstractSubject
{

	private $sFavoris = "";// la liste des modèles de conception favoris
    private $aObserversListe = array();// tableau contenant la liste de tous les objets qui observent le sujet


	/**
	 * constructeur vide
	 */
	public function __construct()
	{ }


	/**
	 * Ajoute un observer
	 * 
	 * @param  AbstractObserver $observerIn [description]
	 * @return [type]                       [description]
	 */
	public function attach(AbstractObserver $observerIn)
	{
		$this->aObserversListe[] = $observerIn;
	}


	/**
	 * Supprime un observer
	 * 
	 * @param  AbstractObserver $observerIn [description]
	 * @return [type]                       [description]
	 */
	public function detach(AbstractObserver $observerIn)
	{
		foreach($this->aObserversListe as $sKey => $oValeur)// recherche de l'objet qui observe à supprimer de la liste
		{
			if ($oValeur == $observerIn)
				unset($this->aObserversListe[$sKey]);
			
		}
	}


	/**
	 * Informe les observers d'un changement d'état du sujet
	 * 
	 * @return [type] [description]
	 */
	public function notify()
	{
		// parcours tous les objets qui observent le sujet pour les prévenir
		foreach($this->aObserversListe as $oObserver)
		{
			$oObserver->update($this);// appelle de la méthode update() sur l'objet qui observe
		}
	}


	/**
	 * Mets à jour la liste des modèles de conception favoris
	 * 
	 * @param  [type] $newFavorites [description]
	 * @return [type]               [description]
	 */
	public function updateFavorites($sNewFavorites)
	{
		$this->sFavoris = $sNewFavorites;
		$this->notify();// informe les observers de la ilse à jour de la liste
	}


	/**
	 * Permet de récupérer la liste des modèles favoris
	 * 
	 * @return [type] [description]
	 */
	public function getFavorites()
	{
		return $this->sFavoris;
	}


}

?>